Subject: Re: [PATCH 1/3] upload-pack: send the HEAD information

From: Junio C Hamano <[email-masked]>
Date: Sun, 08 Sep 2013 10:27:50 -0700

Jeff King <[email-masked]> writes:

> It somehow feels a little weird to me that we would output the
> information about refs/foo on the HEAD line.

I see that you realized why the above is not the case in the
downthread; the capability list is not about describing HEAD. The
list happens to be on the line for HEAD merely because HEAD is the
first ref.

Unfortunately, the "read and replace capability if we see one" (not
"read and update capability with newly discovered one on a second
and subsequent capability list") is a restriction imposed by existing
reader side code that are deployed on the wild, so we need to stick
to it until we revamp the protocol in a backward incompatible way
(which has been discussed a few times; websearch for "who speaks
first" in the list archive).